using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations.Schema;

namespace Elwig.Models {
    [Table("area_commitment_parcel"), PrimaryKey("VNr", "KgNr", "GstNr")]
    public class AreaComParcel {
        [Column("vnr")]
        public int VNr { get; set; }

        [Column("kgnr")]
        public int KgNr { get; set; }

        [Column("gstnr")]
        public string? GstNr { get; set; }

        [Column("rdnr")]
        public int? RdNr { get; set; }

        [Column("area")]
        public int? Area { get; set; }

        [ForeignKey("KgNr")]
        public virtual WbKg Kg { get; private set; }

        [ForeignKey("KgNr, RdNr")]
        public virtual WbRd? Rd { get; private set; }

        [ForeignKey("VNr")]
        public virtual AreaCom AreaCom { get; private set; }
    }
}
