using Elwig.Helpers;
using Microsoft.EntityFrameworkCore;
using System.ComponentModel.DataAnnotations.Schema;

namespace Elwig.Models {
    [Table("wine_quality"), PrimaryKey("QualId")]
    public class WineQual {
        [Column("qualid")]
        public string QualId { get; private set; }

        [Column("origin_level")]
        public int? OriginLevel { get; private set; }

        [Column("predicate")]
        public bool IsPredicate { get; private set; }

        [Column("min_kmw")]
        public double? MinKmw { get; private set; }

        [NotMapped]
        public double? MinOe => MinKmw != null ? Utils.KmwToOe((double)MinKmw) : null;

        [Column("name")]
        public string Name { get; private set; }
    }
}
